// M30xFun.cpp: implementation of the CM30xFun class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "M30xDemo.h"
#include "M30xFun.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


extern CM30xDemoApp theApp;

/****************************************************************************
*
*   Function:			CM30xFun()
*	description:		constructor
*	input:				
*   output:				
*	global variable:	
****************************************************************************/

CM30xFun::CM30xFun()
{
	p_bHostClientDataBuf_WRITE = bHostClientDataBuf_WRITE;
	p_bHostClientDataBuf_READ = bHostClientDataBuf_READ;
	p_ulRawCntsBuff = ulRawCntsBuff;
	p_bDiginBuff = bDiginBuff;
}

/****************************************************************************
*
*   Function:			~CM30xFun()
*	description:		destructor
*	input:				
*   output:				
*	global variable:	
****************************************************************************/

CM30xFun::~CM30xFun()
{

}


/****************************************************************************
*
*   Function:			SendSignon(USHORT usDevID)
*	description:		Sign on procedure
*	input:				USHORT usDevID, BYTE bMaxRetry(max. tries before quit)
*   output:				Error code RETURN_CODE
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::SendSignon(USHORT usDevID)
{
#if 0
	bHostClientDataBuf_WRITE[0] = CMND_SIGN_ON;
	bHostClientDataBuf_WRITE[1] = NO_ARG;
	bHostClientDataBuf_WRITE[2] = CMND_SIGN_ON + NO_ARG;
	BYTE bCurRetry = 0;
	while(bCurRetry < RESET_RETRY_MAX){
		NumBytesToReadWrite = 8;
		if(!theApp.pDLL_ReadWriteOneDevice(DO_WRITE, p_bHostClientDataBuf_WRITE, 
				usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
			bCurRetry++;
			if(!theApp.pDLL_ResetDevice(usDevID, 0)){
				return RESET_DEV_FAILED;//quit instantly if reset failed
			}
			continue;
		}
		Sleep(3000);
		NumBytesToReadWrite = 32;
		if(!theApp.pDLL_ReadWriteOneDevice(DO_READ, p_bHostClientDataBuf_READ, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
			bCurRetry++;
			if(!theApp.pDLL_ResetDevice(usDevID, 0)){
				return RESET_DEV_FAILED;//quit instantly if reset failed
			}
			continue;
		}
		if((bHostClientDataBuf_READ[0] == 1)
			&& (bHostClientDataBuf_READ[1] == 2) 
			&& (bHostClientDataBuf_READ[2] == 3) 
			&& ((bHostClientDataBuf_READ[3] & 0xfe) == 0x22) 
			&& (bHostClientDataBuf_READ[4] == 0) 
			&& (bHostClientDataBuf_READ[5] == 0x8c) 
			&& (bHostClientDataBuf_READ[6] == 0)){
			return SIGN_ON_SUCCESS;
		}
		bCurRetry++;
	}//while loop
	if(bHostClientDataBuf_READ[2] == 0xff) return DEV_NO_POWER;
	return INVALID_DEV_RESPONSE;
#endif
	bHostClientDataBuf_WRITE[0] = CMND_SIGN_ON;
	bHostClientDataBuf_WRITE[1] = NO_ARG;
	bHostClientDataBuf_WRITE[2] = CMND_SIGN_ON + NO_ARG;
	NumBytesToReadWrite = 8;
	if(!theApp.pDLL_ReadWriteOneDevice(DO_WRITE, p_bHostClientDataBuf_WRITE, 
				usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		if(!theApp.pDLL_ResetDevice(usDevID, 0)){
			return RESET_DEV_FAILED;//quit instantly if reset failed
		}
		return SEND_CMD_FAILED;
	}
	return COMMAND_SUCCESS;
}

/****************************************************************************
*
*   Function:			CheckSignon(USHORT usDevID)
*	description:		Sign on procedure
*	input:				USHORT usDevID, BYTE bMaxRetry(max. tries before quit)
*   output:				Error code RETURN_CODE
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::CheckSignon(USHORT usDevID)
{
	NumBytesToReadWrite = 32;
	if(!theApp.pDLL_ReadWriteOneDevice(DO_READ, p_bHostClientDataBuf_READ, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		if(!theApp.pDLL_ResetDevice(usDevID, 0)){
			return RESET_DEV_FAILED;//quit instantly if reset failed
		}
	}
	if((bHostClientDataBuf_READ[0] == 1)
		&& (bHostClientDataBuf_READ[1] == 2) 
		&& (bHostClientDataBuf_READ[2] == 3) 
		&& ((bHostClientDataBuf_READ[3] & 0xfe) == 0x22) 
		&& (bHostClientDataBuf_READ[4] == 0) 
		&& (bHostClientDataBuf_READ[5] == 0x8c) 
		&& (bHostClientDataBuf_READ[6] == 0)){
		return SIGN_ON_SUCCESS;
	}
	if(bHostClientDataBuf_READ[2] == 0xff) return DEV_NO_POWER;
	return INVALID_DEV_RESPONSE;

}
/****************************************************************************
*
*   Function:			SendRate(USHORT usDevID,double* fRate)
*	description:		Send rate procedure
*	input:				USHORT usDevID, double fRate
*   output:				Error code RETURN_CODE
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::SendRate(USHORT usDevID,double* fRate)
{
	if(*fRate > 1001.0) return INVALID_ARGUMENT;
	if(!CalcRateCodes(&bLow,&bMid,&bHigh,fRate)){
		return SET_RATE_FAILED;
	}
	bHostClientDataBuf_WRITE[0] = CMND_SET_MODE;
	bHostClientDataBuf_WRITE[1] = bLow;
	bHostClientDataBuf_WRITE[2] = bMid;
	bHostClientDataBuf_WRITE[3] = bHigh;
	bHostClientDataBuf_WRITE[4] = 0x22;
	NumBytesToReadWrite = 8;
	if(!theApp.pDLL_ReadWriteOneDevice(DO_WRITE, p_bHostClientDataBuf_WRITE, 
			usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		return SET_RATE_FAILED;
	}

	Sleep(3000);

	NumBytesToReadWrite = 32;
	if(!theApp.pDLL_ReadWriteOneDevice(DO_READ, p_bHostClientDataBuf_READ, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
	}
	if((bHostClientDataBuf_READ[0] == 1)
		&& (bHostClientDataBuf_READ[1] == 2) 
		&& (bHostClientDataBuf_READ[2] == 3) 
		&& ((bHostClientDataBuf_READ[3] & 0xfe) == 0x22) 
		&& (bHostClientDataBuf_READ[4] == bHigh) 
		&& (bHostClientDataBuf_READ[5] == bMid) 
		&& (bHostClientDataBuf_READ[6] == bLow)){

		if(!theApp.pDLL_SetRate(usDevID, *fRate))
		{
			//MessageBox(GetForegroundWindow(), "pDLL_SetRate failed", "", 0);
			return SET_RATE_FAILED;
		}
		else
		{
			//MessageBox(GetForegroundWindow(), "pDLL_SetRate success", "", 0);
		}


		return COMMAND_SUCCESS;
	}
	if(bHostClientDataBuf_READ[2] == 0xff){
		return DEV_NO_POWER;
	}
	return SET_RATE_FAILED;
}


/****************************************************************************
*
*   Function:			CalcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, double* fRate)
*	description:		Based on fRate, caculate 3 bytes need to send to M30x board
*	input:				double fRate
*   output:				BYTE* bLow, BYTE* bMid, BYTE* bHigh
*	global variable:	
****************************************************************************/
BOOL CM30xFun::CalcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, double* fRate)
{
	BYTE bModeFlagBit = 0x80;
	double dbRateTemp = *fRate;
	//constant for rate calculation. Is crystal frequency /512
	UINT lKVal = 9830400l / 512	;	
	BYTE bTypeMode = 16;
	double dbIntervalTemp = 1.0 / dbRateTemp;
	SHORT sRateCount = (SHORT)(lKVal * bTypeMode * dbIntervalTemp + 0.5);
	USHORT sRateCmndLow = sRateCount & 0xff;
	*bLow = (BYTE)sRateCmndLow;
	USHORT sRateCmdMid = bModeFlagBit | ((sRateCount & 0x1f00) / 256);
	*bMid = (BYTE)sRateCmdMid;
	*bHigh = 0;
	double ActualInterval = (double)(((sRateCmdMid & 0x1f) * 256) 
				+ sRateCmndLow) / (lKVal * bTypeMode);
	double ActualRate = (1.0 / ActualInterval);
	*fRate = ActualRate;
	return TRUE;
}

/****************************************************************************
*
*   Function:			ChangeChan(USHORT usDevID,BYTE bCurChan)
*	description:		Switch M30x internal channel
*	input:				USHORT usDevID, BYTE bCurChan
*   output:				Error code RETURN_CODE
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::ChangeChan(USHORT usDevID,BYTE bCurChan)
{
	bHostClientDataBuf_WRITE[0] = CMND_CHAN_CHG;
	bHostClientDataBuf_WRITE[1] = bCurChan;
	bHostClientDataBuf_WRITE[2] = CMND_CHAN_CHG + bCurChan;
	NumBytesToReadWrite = 8;
	if(!theApp.pDLL_ReadWriteOneDevice(DO_WRITE, p_bHostClientDataBuf_WRITE, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		return SEND_CMD_FAILED;
	}
	return COMMAND_SUCCESS;
}

/****************************************************************************
*
*   Function:			StartScan(USHORT usDevID)
*	description:		Start scan
*	input:				USHORT usDevID
*   output:				Error code RETURN_CODE
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::StartScan(USHORT usDevID,_SCAN_OBJECT_DIO* p_ScanObj)
{
	if(!theApp.pDLL_StartScan(usDevID,p_ScanObj,ARG_IGNORED)){
		return SEND_CMD_FAILED;
	}
	return COMMAND_SUCCESS;
}

/****************************************************************************
*
*   Function:			EndScan(USHORT usDevID)
*	description:		End scan
*	input:				USHORT usDevID
*   output:				Error code RETURN_CODE
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::EndScan(USHORT usDevID)
{
	if(!theApp.pDLL_EndScan(usDevID,ARG_IGNORED,ARG_IGNORED,ARG_IGNORED)){
		return SEND_CMD_FAILED;
	}
	return COMMAND_SUCCESS;
}

/****************************************************************************
*
*   Function:			GetConversion(USHORT usDevID,double* volts_result)
*	description:		In Poll mode get one conversion
*	input:				USHORT usDevID
*   output:				Error code RETURN_CODE,volts_result
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::GetConversion(USHORT usDevID,double* volts_result)
{
	Sleep(50);
	bHostClientDataBuf_WRITE[0] = CMND_GET_CONVERSION;
	bHostClientDataBuf_WRITE[1] = NO_ARG;
	bHostClientDataBuf_WRITE[2] = CMND_GET_CONVERSION + NO_ARG;
	NumBytesToReadWrite = 8;
	//send get conversion command first
	if(!theApp.pDLL_ReadWriteOneDevice(DO_WRITE, p_bHostClientDataBuf_WRITE, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		return SEND_CMD_FAILED;
	}
	//read the result now
	NumBytesToReadWrite = 32;
	if(!theApp.pDLL_ReadWriteOneDevice(DO_READ, p_bHostClientDataBuf_READ, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		*volts_result = 0;
		if(!theApp.pDLL_ResetDevice(usDevID, 0)){
			return RESET_DEV_FAILED;//quit instantly if reset failed
		}
		return READ_CONVERSION_FAILED;

	}
	if(bHostClientDataBuf_READ[2] == 0xff){
		*volts_result = 0;
		return DEV_NO_POWER;
	}
	UINT ulCnt = (UINT)(bHostClientDataBuf_READ[6] << 16) + 
		(UINT)(bHostClientDataBuf_READ[5] << 8) +
		(UINT)(bHostClientDataBuf_READ[4]);
	*volts_result = CONV_VOLT((INT)ulCnt);
	return COMMAND_SUCCESS;
}

/****************************************************************************
*
*   Function:			SendDigitalOut(USHORT usDevID,BYTE bDigOut)
*	description:		Send 8 bit digital data to M30x output port
*	input:				USHORT usDevID,BYTE bDigOut
*   output:				Error code RETURN_CODE
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::SendDigitalOut(USHORT usDevID,BYTE bDigOut)
{
	bHostClientDataBuf_WRITE[0] = CMND_DIG_OUT;
	bHostClientDataBuf_WRITE[1] = bDigOut;
	bHostClientDataBuf_WRITE[2] = (BYTE)(CMND_DIG_OUT + bDigOut);
	NumBytesToReadWrite = 8;
	//send get conversion command first
	if(!theApp.pDLL_ReadWriteOneDevice(DO_WRITE, p_bHostClientDataBuf_WRITE, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		return SEND_CMD_FAILED;
	}
	return COMMAND_SUCCESS;
}


/****************************************************************************
*
*   Function:			SysCal(USHORT usDevID)
*	description:		Do system caliberation
*	input:				USHORT usDevID
*   output:				Error code RETURN_CODE
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::SysCal(USHORT usDevID)
{
	bHostClientDataBuf_WRITE[0] = CMND_SYS_CAL;
	bHostClientDataBuf_WRITE[1] = 0;
	bHostClientDataBuf_WRITE[2] = (BYTE)(CMND_SYS_CAL + 0);
	bHostClientDataBuf_WRITE[3] = 0;
	bHostClientDataBuf_WRITE[4] = 0;
	NumBytesToReadWrite = 8;
	//send get conversion command first
	if(!theApp.pDLL_ReadWriteOneDevice(DO_WRITE, p_bHostClientDataBuf_WRITE, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		return SEND_CMD_FAILED;
	}
//'=======================================================================
//'=== Wait settling time for calibration ================================
//'=======================================================================
	Sleep(2000);
//'=======================================================================
//'=== Get results from system calibration ===============================
//'=======================================================================
	NumBytesToReadWrite = 32;
	if(!theApp.pDLL_ReadWriteOneDevice(DO_READ, p_bHostClientDataBuf_READ, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		return CALIBERATE_DEV_FAILED;
	}
//'=======================================================================
//'=== View values returned by board after sending syscal ================
//'=======================================================================
	if((bHostClientDataBuf_READ[0] == 1)
		&& (bHostClientDataBuf_READ[1] == 2) 
		&& (bHostClientDataBuf_READ[2] == 3)){
		return COMMAND_SUCCESS;
	}
	if(bHostClientDataBuf_READ[2] == 0xff){
		return DEV_NO_POWER;
	}
	return CALIBERATE_DEV_FAILED;
}



/****************************************************************************
*
*   Function:			SendDigitalOut(USHORT usDevID,BYTE bDigOut)
*	description:		Send 8 bit digital data to M30x output port
*	input:				USHORT usDevID,BYTE bDigOut
*   output:				Error code RETURN_CODE
*	global variable:	
****************************************************************************/
RETURN_CODE CM30xFun::SendDACOut(USHORT usDevID,double fVolts, BYTE bChanIndex)
{
	long sCount;
	BYTE bHigh,bLow;
	sCount = (long)(fVolts * 16383 / 5);
	sCount = sCount & 0x3fff;  //set max.
	bHigh = (BYTE)(sCount >> 6);//high byte 
	bLow = (BYTE)(sCount);//low byte
	bLow = (bLow << 2) + (bChanIndex & 0x03);
	bHostClientDataBuf_WRITE[0] = CMND_ANALOG_OUT;
	bHostClientDataBuf_WRITE[1] = bHigh;
	bHostClientDataBuf_WRITE[2] = (BYTE)(CMND_ANALOG_OUT + bHigh);
	bHostClientDataBuf_WRITE[3] = bLow;
	bHostClientDataBuf_WRITE[4] = bLow;
	NumBytesToReadWrite = 8;
	//send get conversion command first
	if(!theApp.pDLL_ReadWriteOneDevice(DO_WRITE, p_bHostClientDataBuf_WRITE, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		return SEND_CMD_FAILED;
	}
	return COMMAND_SUCCESS;
}

RETURN_CODE CM30xFun::CheckPower(USHORT usDevID)
{
	//Try to read
	NumBytesToReadWrite = 32;
	if(!theApp.pDLL_ReadWriteOneDevice(DO_READ, p_bHostClientDataBuf_READ, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		//if read failed try to reset pipe
		if(!theApp.pDLL_ResetPipe(usDevID,ARG_IGNORED,DO_READ)){
			if(SendReset(usDevID) != COMMAND_SUCCESS){
				return RESET_DEV_FAILED;
			}
		}
	}
	if(bHostClientDataBuf_READ[2] == 0xff){
		return DEV_NO_POWER;
	}
	if(!theApp.pDLL_ResetPipe(usDevID,ARG_IGNORED,DO_READ)){
		return SEND_CMD_FAILED;
	}
	return COMMAND_SUCCESS;
}

RETURN_CODE CM30xFun::SendReset(USHORT usDevID)
{
	bHostClientDataBuf_WRITE[0] = CMND_RESET;
	bHostClientDataBuf_WRITE[1] = 0;
	bHostClientDataBuf_WRITE[2] = 1;
	NumBytesToReadWrite = 8;
	//send get conversion command first
	if(!theApp.pDLL_ReadWriteOneDevice(DO_WRITE, p_bHostClientDataBuf_WRITE, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		return SEND_CMD_FAILED;
	}
	Sleep(2000);
//'=======================================================================
//'=======================================================================
	NumBytesToReadWrite = 32;
	if(!theApp.pDLL_ReadWriteOneDevice(DO_READ, p_bHostClientDataBuf_READ, 
		usDevID, &NumBytesToReadWrite, &bLastDigin, 0)){
		return RESET_DEV_FAILED;
	}
	if(bHostClientDataBuf_READ[2] == 0xff){
		return DEV_NO_POWER;
	}
	return COMMAND_SUCCESS;
}
